#!/usr/bin/perl
use strict;
use warnings;
use lib qw(./lib);
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use CGI::Session;
use Flickr::API;
use XML::Parser::Lite::Tree::XPath;
# Ĺ XPath Υ饹̾ѿư䤹 
my $XPathClass = 'XML::Parser::Lite::Tree::XPath';

# CGI Υ֥Ȥ롥 
my $q = CGI->new;

# Flickr API Υ֥Ⱥ 
#   key  secret ϡFlickr Services (http://www.flickr.com/services/) 
#   ȯԤƤäͤ򥻥åȤ롥 
my $api = Flickr::API->new({key => '..', secret => '..'});
# Хå PATH_INFO
#   ˥ХåȾȲ򤪤ʤ 
my $VERIFY_PATH = '/verify.flickr';
# 󡦥󥯤 URI  
my $login_uri = $api->request_auth_url('read');

my $action_uri = ''; # OpenID(Flickr̤) 
sub process_login { die "cannot /login" } # OpenID(FlickrǤ̤) 

# Ȳ񥵥֥롼 
#  Хå URI Ϥ줿ǧھ(frob ѥ᡼)¤줿 
#  Τɤ API ȤäǧڥФ˾Ȳ񤹤롥
#  Ȳ顤Ⱦ֤ΤǡФƤ 
#
#  Ȥ: my $user_info = process_verify($api, $q);
#  : ȾǼ᤿ϥå塦ե 
#     -field ˥ȾΥڡڤ 
#  :
#    $api -- ǧ API ֥
#    $q   -- CGI ֥
sub process_verify {
    my($api, $q) = @_;
    # Хå URI  brob ѥ᡼Ф 
    my $frob = $q->param('frob');
    # flickr.auth.getToken 򥳡뤷ƥȡ롥 
    my $res = $api->execute_method('flickr.auth.getToken', {frob => $frob});
    $res->{success} or die $res->{error_message};
    # 쥹ݥ󥹤 XML ĥ꡼ nsid  ȡФ 
    my $xpath = $XPathClass->new($res->{tree});
    my ($node) = $xpath->select_nodes('/auth/user');
    my $nsid = $node->{attributes}{nsid};
    ($node) = $xpath->select_nodes('/auth/token');
    my $token = $node->{children}[0]{content};
    # flickr.people.getInfo 򥳡뤷ƥȾ롥 
    $res =  $api->execute_method('flickr.people.getInfo', {
        user_id => $nsid, auth_token => $token
    });
    $res->{success} or die $res->{error_message};
    # 쥹ݥ󥹤 XML ĥ꡼饢ȾФ 
    $xpath = $XPathClass->new($res->{tree});
    my $uinfo = {
        -fields => 'username realname mbox_sha1sum profileurl photosurl'
    };
    for my $f (split / /, $uinfo->{-fields}) {
        my($node) = $xpath->select_nodes("/person/$f");
        $uinfo->{$f} = $node->{children}[0]{content};
    }
    $uinfo;
}

# ʲ API ʬ 

# CGI-Session Τ 
my $session; # å󡦥֥ȤǼѿ 
my $DNS = "driver:file"; # åǼˤϥեѤ 
my $OPT = {Directory=>'./session'}; # åǼǥ쥯ȥ 
my $SID = 'ss'; # åIDϿ륯å̾ 
# ֥饦åssϤ顤åƤե뤫ɤ߼ 
if (my $sid = $q->cookie($SID)) {
    $session = CGI::Session->new($DNS, $sid, $OPT) or die CGI::Session->errstr;
    if ($sid ne $session->id) {
        # ͭ¤᤮ȯԤƤʤåξϺ 
        $session->delete;
        $session = undef;
    }
}
if ($q->path_info eq '/login') {
    process_login($api, $q); # OpenIDΥ򤪤ʤ 
} elsif ($q->path_info eq $VERIFY_PATH) {
    my $user_info = process_verify($api, $q); # Ȳ򤪤ʤ 
    # ǧξϥå򿷤ꥢȾϿ 
    $session->delete if $session;
    $session = CGI::Session->new($DNS, undef, $OPT) or die CGI::Session->errstr;
    $session->expire('+1h');
    $session->param(%$user_info);
    # åID򥯥å˥åȤ 
    print $q->redirect(
        -uri => $q->url,
        -cookie => $q->cookie($SID, $session->id)
    );
    exit;
} elsif ($q->path_info eq '/logout') {
    # åȥå뤳ȤǥȤ 
    $session->delete if $session;
    print $q->redirect(
        -uri => $q->url,
        -cookie => $q->cookie(
            -name => $SID, -value => '', -expires => '-1d'
        )
    );
    exit;
}
# ڡɽ 
print $q->header(-charset => 'UTF-8');
print $q->start_html('Web Auth'), $q->h1('Web Auth');
if (! $session && $login_uri) {
    # OpenID ʳΥ󡦥󥯤ɽ롥 
    print $q->p($q->a({-href=>$login_uri}, 'LOGIN'));
} elsif (! $session && $action_uri) {
    # OpenID Υ󡦥եɽ롥 
    print
       $q->start_form(-action => $action_uri),
       'OpenID: ',
       $q->textfield(-name => 'openid_url'),
       $q->submit(-value => ' LOGIN '),
       $q->end_form;
} else {
    # å˵ϿƤ륢Ⱦȥȥ󥯤ɽ롥 
    print
        $q->p($q->a({-href=>$q->url.'/logout'}, 'LOGOUT')),
        $q->ul(
            $q->li([map {
                $q->escapeHTML("$_ = " . $session->param($_))
            } split / /, $session->param('-fields')])
        );
}
print $q->end_html, "\n";
