#!/usr/bin/perl
use strict;
use warnings;
use lib qw(./lib);
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use CGI::Session;
use Net::OpenID::Consumer;
use LWP::UserAgent;
use URI;

# CGI Υ֥Ȥ롥 
my $q = CGI->new;

# OpenID Υ֥Ⱥ 
#   ua ˤ LWP::UserAgent ޤϸߴ饤֥ꤹ롥 
#   args ˤ CGI ֥Ȥꤹ롥 
#   consumer_secret ˤ CGI ץȤκԤʸ򥻥åȤ롥 
my $api = Net::OpenID::Consumer->new(
    ua => LWP::UserAgent->new,
    args => $q,
    consumer_secret => '..',
);
# Хå PATH_INFO
#   ˥ХåȾȲ򤪤ʤ 
my $VERIFY_PATH = '/verify.openid';
# 󡦥եΥ˻ꤹ URI 롥 
my $action_uri = URI->new($q->url . '/login');

my $login_uri = ''; # 󡦥 URI (OpenIDǤ̤) 

# 
#   եफä OpenID  Identity  OpenID Ф
#   õФإ桼ǧڤνѤͤ롥 
#   ФǧȤϡХå URI ƤӽФơ 
#   Ȳ˰ܤ롥 
#
#   : ʤ 
#     (HTTP ơ 302 Υ쥹ݥ󥹤֤CGIץȤߤ) 
#   :
#     $api -- Net::OpenID::Consumer Υ֥ 
#     $q   -- CGI Υ֥ 
#     $param -- {foo => 'bar'} ʤɤΥХå URI Ϥѥ᡼ 
#             (ѥ᡼ͤ URI  ưŪ URI פ)
sub process_login {
    my($api, $q, $param) = @_;
    # Identity ϤǧڥФõ 
    $q->request_method eq 'POST' or die "must POST";
    my $identity = $q->param('openid_url');
    my $claimed = $api->claimed_identity($identity) or die $api->err;
    # Хå URI  
    my $return_to = URI->new($q->url . $VERIFY_PATH);
    $return_to->query_form(%$param) if $param && %$param;
    #  URI  
    my $check_url = $claimed->check_url(
        return_to => $return_to->as_string,
        trust_root => $q->url,
    );
    #  URI ˽ܤ 
    print $q->redirect(-uri => $check_url);
    exit;
}

# Ȳ񥵥֥롼 
#  Хå URI Ϥ줿ǧھ󤬵¤줿 
#  ΤɤȲ񤹤롥
#  Ȳ顤Ⱦ֤ΤǡФƤ 
#
#  Ȥ: my $user_info = process_verify($api, $q);
#  : ȾǼ᤿ϥå塦ե 
#     -field ˥ȾΥڡڤ 
#  :
#    $api -- ǧ API ֥
#    $q   -- CGI ֥
sub process_verify {
    my($api, $q) = @_;
    if (my $url = $api->user_setup_url) {
        # ¾ URL ذư 
        print $q->redirect(-url => $url);
    } elsif ($api->user_cancel) {
        # 󥻥뤵줿 
        print $q->redirect(-url => $q->url);
    } elsif (my $vident = $api->verified_identity) {
        # Ȳ 
        return +{
            -fields => 'url rss atom foaf',
            url => $vident->url,
            rss => $vident->rss,
            atom => $vident->atom,
            foaf => $vident->foaf,
        };
    } else {
        # ޤȤȯ 
        die $api->err;
    }
    exit;
}

# ʲ API ʬ 

# CGI-Session Τ 
my $session; # å󡦥֥ȤǼѿ 
my $DNS = "driver:file"; # åǼˤϥեѤ 
my $OPT = {Directory=>'./session'}; # åǼǥ쥯ȥ 
my $SID = 'ss'; # åIDϿ륯å̾ 
# ֥饦åssϤ顤åƤե뤫ɤ߼ 
if (my $sid = $q->cookie($SID)) {
    $session = CGI::Session->new($DNS, $sid, $OPT) or die CGI::Session->errstr;
    if ($sid ne $session->id) {
        # ͭ¤᤮ȯԤƤʤåξϺ 
        $session->delete;
        $session = undef;
    }
}
if ($q->path_info eq '/login') {
    process_login($api, $q); # OpenIDΥ򤪤ʤ 
} elsif ($q->path_info eq $VERIFY_PATH) {
    # Ȳ򤪤ʤ 
    my $user_info = process_verify($api, $q);
    # ǧξϥå򿷤ꥢȾϿ 
    $session->delete if $session;
    $session = CGI::Session->new($DNS, undef, $OPT) or die CGI::Session->errstr;
    $session->expire('+1h');
    $session->param(%$user_info);
    # åID򥯥å˥åȤ 
    print $q->redirect(
        -uri => $q->url,
        -cookie => $q->cookie($SID, $session->id)
    );
    exit;
} elsif ($q->path_info eq '/logout') {
    # åȥå뤳ȤǥȤ 
    $session->delete if $session;
    print $q->redirect(
        -uri => $q->url,
        -cookie => $q->cookie(
            -name => $SID, -value => '', -expires => '-1d'
        )
    );
    exit;
}
# ڡɽ 
print $q->header(-charset => 'UTF-8');
print $q->start_html('Web Auth'), $q->h1('Web Auth');
if (! $session && $login_uri) {
    # OpenID ʳΥ󡦥󥯤ɽ롥 
    print $q->p($q->a({-href=>$login_uri}, 'LOGIN'));
} elsif (! $session && $action_uri) {
    # OpenID Υ󡦥եɽ롥 
    print
       $q->start_form(-action => $action_uri),
       'OpenID: ',
       $q->textfield(-name => 'openid_url'),
       $q->submit(-value => ' LOGIN '),
       $q->end_form;
} else {
    # å˵ϿƤ륢Ⱦȥȥ󥯤ɽ롥 
    print
        $q->p($q->a({-href=>$q->url.'/logout'}, 'LOGOUT')),
        $q->ul(
            $q->li([map {
                $q->escapeHTML("$_ = " . $session->param($_))
            } split / /, $session->param('-fields')])
        );
}
print $q->end_html, "\n";
