#!/usr/bin/perl
use strict;
use warnings;
use lib qw(./lib);
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use CGI::Session;
use Authen::TypeKey;
use URI;

# CGI Υ֥Ȥ롥 
my $q = CGI->new;

# TypeKey API Υ֥Ȥκ 
#   token ˤϡTypeKey  (https://www.typekey.com/t/typekey/?lang=ja)
#   ȯԤͤ򥻥åȤ롥 
my $api = Authen::TypeKey->new;
$api->token('..');
# Хå PATH_INFO
#   ˥ХåȾȲ򤪤ʤ 
my $VERIFY_PATH = '/verify.typekey';
# 󡦥󥯤 URI  
my $login_uri = uri_to_login($api, $q, {foo => 'bar'});

# URI륵֥롼 
#   Ȥ: my $login_uri = uri_to_login($api, $q, {foo => 'bar'});
#   :  URI Ǽ᤿ URI ֥
#   : 
#       $api -- Authen::TypeKey ֥
#       $q   -- CGI ֥
#       {foo => 'bar'} -- Хå URI Ϥѥ᡼
#               (ѥ᡼ͤ URI  ưŪ URI פ)
sub uri_to_login {
    my($api, $q, $param) = @_;
    # ХåURI 
    my $_return = URI->new($q->url . $VERIFY_PATH);
    $_return->query_form(%$param) if $param && %$param;
    # ȥȡѥ᡼ˤƥURI 
    my $login_uri = URI->new('https://www.typekey.com/t/typekey/login');
    $login_uri->query_form(
        lang => 'ja', v => '1.1',
        t => $api->token,
        _return => $_return->as_string
    );
    return $login_uri;
}

my $action_uri = ''; # OpenID(TypeKeyǤ̤) 
sub process_login { die "cannot /login" } # OpenID(TypeKeyǤ̤) 

# Ȳ񥵥֥롼 
#  Хå URI Ϥ줿ǧھ󤬵¤줿 
#  ΤɤȲ񤹤롥
#  Ȳ顤Ⱦ֤ΤǡФƤ 
#
#  Ȥ: my $user_info = process_verify($api, $q);
#  : ȾǼ᤿ϥå塦ե 
#     -field ˥ȾΥڡڤ 
#  :
#    $api -- ǧ API ֥
#    $q   -- CGI ֥
sub process_verify {
    my($api, $q) = @_;
    my $res = $api->verify($q) or die $api->errstr;
    return +{
        -fields => 'name nick email ts',
        name => $res->{name},
        nick => $res->{nick},
        email => $res->{email},
        ts => $res->{ts},
    };
}

# ʲ API ʬ 

# CGI-Session Τ 
my $session; # å󡦥֥ȤǼѿ 
my $DNS = "driver:file"; # åǼˤϥեѤ 
my $OPT = {Directory=>'./session'}; # åǼǥ쥯ȥ 
my $SID = 'ss'; # åIDϿ륯å̾ 
# ֥饦åssϤ顤åƤե뤫ɤ߼ 
if (my $sid = $q->cookie($SID)) {
    $session = CGI::Session->new($DNS, $sid, $OPT) or die CGI::Session->errstr;
    if ($sid ne $session->id) {
        # ͭ¤᤮ȯԤƤʤåξϺ 
        $session->delete;
        $session = undef;
    }
}
if ($q->path_info eq '/login') {
    process_login($api, $q); # OpenIDΥ򤪤ʤ 
} elsif ($q->path_info eq $VERIFY_PATH) {
    # Ȳ򤪤ʤ 
    my $user_info = process_verify($api, $q);
    # ǧξϥå򿷤ꥢȾϿ 
    $session->delete if $session;
    $session = CGI::Session->new($DNS, undef, $OPT) or die CGI::Session->errstr;
    $session->expire('+1h');
    $session->param(%$user_info);
    # åID򥯥å˥åȤ 
    print $q->redirect(
        -uri => $q->url,
        -cookie => $q->cookie($SID, $session->id)
    );
    exit;
} elsif ($q->path_info eq '/logout') {
    # åȥå뤳ȤǥȤ 
    $session->delete if $session;
    print $q->redirect(
        -uri => $q->url,
        -cookie => $q->cookie(
            -name => $SID, -value => '', -expires => '-1d'
        )
    );
    exit;
}
# ڡɽ 
print $q->header(-charset => 'UTF-8');
print $q->start_html('Web Auth'), $q->h1('Web Auth');
if (! $session && $login_uri) {
    # OpenID ʳΥ󡦥󥯤ɽ롥 
    print $q->p($q->a({-href=>$login_uri}, 'LOGIN'));
} elsif (! $session && $action_uri) {
    # OpenID Υ󡦥եɽ롥 
    print
       $q->start_form(-action => $action_uri),
       'OpenID: ',
       $q->textfield(-name => 'openid_url'),
       $q->submit(-value => ' LOGIN '),
       $q->end_form;
} else {
    # å˵ϿƤ륢Ⱦȥȥ󥯤ɽ롥 
    print
        $q->p($q->a({-href=>$q->url.'/logout'}, 'LOGOUT')),
        $q->ul(
            $q->li([map {
                $q->escapeHTML("$_ = " . $session->param($_))
            } split / /, $session->param('-fields')])
        );
}
print $q->end_html, "\n";
